

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Supported hypercalls &mdash; Xen 4.16-unstable documentation</title>
  

  
  
  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  

  

  
        <link rel="index" title="Index"
              href="../../genindex.html"/>
        <link rel="search" title="Search" href="../../search.html"/>
    <link rel="top" title="Xen 4.16-unstable documentation" href="../../index.html"/>
        <link rel="up" title="Hypercall Interfaces - arm64" href="../arm64.html"/>
        <link rel="next" title="List of hypercalls" href="list_of_hypercalls.html"/>
        <link rel="prev" title="Hypercall Calling Convention" href="hypercall_calling_convention.html"/> 

  
  <script src="../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

   
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../index.html" class="icon icon-home"> Xen
          

          
          </a>

          
            
            
              <div class="version">
                4.16
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../admin-guide/index.html">Admin Guide</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../guest-guide/index.html">Guest documentation</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../hypervisor-guide/index.html">Hypervisor documentation</a></li>
</ul>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../index.html">Hypercall Interfaces</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="../arm64.html">Hypercall Interfaces - arm64</a><ul class="current">
<li class="toctree-l3 current"><a class="reference internal" href="../arm64.html#starting-points">Starting points</a><ul class="current">
<li class="toctree-l4"><a class="reference internal" href="hypercall_calling_convention.html">Hypercall Calling Convention</a></li>
<li class="toctree-l4 current"><a class="current reference internal" href="#">Supported hypercalls</a></li>
<li class="toctree-l4"><a class="reference internal" href="list_of_hypercalls.html">List of hypercalls</a></li>
<li class="toctree-l4"><a class="reference internal" href="guest_scheduler_operations.html">Guest Scheduler Operations</a></li>
<li class="toctree-l4"><a class="reference internal" href="grant_tables.html">Grant Tables</a></li>
<li class="toctree-l4"><a class="reference internal" href="event_channels.html">Event Channels</a></li>
<li class="toctree-l4"><a class="reference internal" href="xenstore_wire_protocol.html">XenStore wire protocol</a></li>
<li class="toctree-l4"><a class="reference internal" href="start_of_day_shared_data_structure.html">Start-of-day shared data structure</a></li>
<li class="toctree-l4"><a class="reference internal" href="start_of_day_memory_layout.html">Start-of-day memory layout</a></li>
<li class="toctree-l4"><a class="reference internal" href="dom0_console.html">Dom0 console</a></li>
<li class="toctree-l4"><a class="reference internal" href="xen_elfnote_features.html">XEN ELFNOTE FEATURES</a></li>
<li class="toctree-l4"><a class="reference internal" href="elf_notes.html">ELF notes</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#functions">Functions</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#structs">Structs</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#enums-and-sets-of-defines">Enums and sets of #defines</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#typedefs">Typedefs</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#enum-values-and-individual-defines">Enum values and individual #defines</a></li>
</ul>
</li>
</ul>
</li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../glossary.html">Glossary</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Xen</a>
        
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../index.html">Hypercall Interfaces</a> &raquo;</li>
        
          <li><a href="../arm64.html">Hypercall Interfaces - arm64</a> &raquo;</li>
        
      <li>Supported hypercalls</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/hypercall-interfaces/common/supported_hypercalls.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="supported-hypercalls">
<h1>Supported hypercalls<a class="headerlink" href="#supported-hypercalls" title="Permalink to this headline">¶</a></h1>
<dl class="group">
<dt>
<span class="target" id="group__supported__hypercalls"></span><em>group</em> <code class="descname">supported_hypercalls</code></dt>
<dd><p>Xen on ARM makes extensive use of hardware facilities and therefore only a subset of the potential hypercalls are required. </p>
<p>Since ARM uses second stage paging any machine/physical addresses passed to hypercalls are Guest Physical Addresses (Intermediate Physical Addresses) unless otherwise noted.</p>
<p>The following hypercalls (and sub operations) are supported on the ARM platform. Other hypercalls should be considered unavailable/unsupported.</p>
<p>HYPERVISOR_memory_op All generic sub-operations</p>
<p>HYPERVISOR_domctl All generic sub-operations, with the exception of:<ul class="simple">
<li>XEN_DOMCTL_irq_permission (not yet implemented)</li>
</ul>
</p>
<p>HYPERVISOR_sched_op All generic sub-operations, with the exception of:<ul class="simple">
<li>SCHEDOP_block  prefer wfi hardware instruction</li>
</ul>
</p>
<p>HYPERVISOR_console_io All generic sub-operations</p>
<p>HYPERVISOR_xen_version All generic sub-operations</p>
<p>HYPERVISOR_event_channel_op All generic sub-operations</p>
<p>HYPERVISOR_physdev_op No sub-operations are currenty supported</p>
<p>HYPERVISOR_sysctl All generic sub-operations, with the exception of:<ul class="simple">
<li>XEN_SYSCTL_page_offline_op</li>
<li>XEN_SYSCTL_get_pmstat</li>
<li>XEN_SYSCTL_pm_op</li>
</ul>
</p>
<p>HYPERVISOR_hvm_op Exactly these sub-operations are supported:<ul class="simple">
<li>HVMOP_set_param</li>
<li>HVMOP_get_param</li>
</ul>
</p>
<p>HYPERVISOR_grant_table_op All generic sub-operations</p>
<p>HYPERVISOR_vcpu_op Exactly these sub-operations are supported:<ul class="simple">
<li>VCPUOP_register_vcpu_info</li>
<li>VCPUOP_register_runstate_memory_area</li>
</ul>
</p>
<p>Other notes on the ARM ABI:</p>
<p><ul class="simple">
<li>struct start_info is not exported to ARM guests.</li>
<li>struct <a class="reference internal" href="start_of_day_shared_data_structure.html#structshared__info"><span class="std std-ref">shared_info</span></a> is mapped by ARM guests using the HYPERVISOR_memory_op sub-op XENMEM_add_to_physmap, passing XENMAPSPACE_shared_info as space parameter.</li>
<li>All the per-cpu struct vcpu_info are mapped by ARM guests using the HYPERVISOR_vcpu_op sub-op VCPUOP_register_vcpu_info, including cpu0 struct vcpu_info.</li>
<li>The grant table is mapped using the HYPERVISOR_memory_op sub-op XENMEM_add_to_physmap, passing XENMAPSPACE_grant_table as space parameter. The memory range specified under the Xen compatible hypervisor node on device tree can be used as target gpfn for the mapping.</li>
<li>Xenstore is initialized by using the two hvm_params HVM_PARAM_STORE_PFN and HVM_PARAM_STORE_EVTCHN. They can be read with the HYPERVISOR_hvm_op sub-op HVMOP_get_param.</li>
<li>The paravirtualized console is initialized by using the two hvm_params HVM_PARAM_CONSOLE_PFN and HVM_PARAM_CONSOLE_EVTCHN. They can be read with the HYPERVISOR_hvm_op sub-op HVMOP_get_param.</li>
<li>Event channel notifications are delivered using the percpu GIC interrupt specified under the Xen compatible hypervisor node on device tree.</li>
<li>The device tree Xen compatible node is fully described under Linux at Documentation/devicetree/bindings/arm/xen.txt. </li>
</ul>
</p>
</dd></dl>

</div>


           </div>
           <div class="articleComments">
            
           </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="list_of_hypercalls.html" class="btn btn-neutral float-right" title="List of hypercalls" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="hypercall_calling_convention.html" class="btn btn-neutral" title="Hypercall Calling Convention" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, The Xen development community.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../',
            VERSION:'4.16-unstable',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true,
            SOURCELINK_SUFFIX: '.txt'
        };
    </script>
      <script type="text/javascript" src="../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../_static/doctools.js"></script>

  

  
  
    <script type="text/javascript" src="../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>